/*******************************************************************************
 * FoxDroppedPickup_Generic generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDroppedPickup_Generic extends FoxDroppedPickup
    hidecategories(Navigation);

var transient FoxDataProvider_GenericPickup Provider;
var export editinline transient ParticleSystemComponent ActivePSC;
var repnotify transient name ProviderName;
var repnotify transient Vector InitialVelocity;
var transient bool bActivated;

replication
{
    // Pos:0x000
    if(Role == ROLE_Authority)
        InitialVelocity, ProviderName, 
        bActivated
}

simulated event ReplicatedEvent(name VarName)
{
    local DataStoreClient DSClient;
    local FoxDataProvider_GenericPickup FoundProvider;

    super(DroppedPickup).ReplicatedEvent(VarName);
    // End:0xC4
    if(VarName == 'ProviderName')
    {
        DSClient = class'UIInteraction'.static.GetDataStoreClient();
        FoundProvider = FoxDataStore_GenericPickup(DSClient.FindDataStore('FoxGenericPickups')).FindPickupByName(ProviderName);
        InitializeFrom(FoundProvider);
    }
    // End:0xEE
    else
    {
        // End:0xEE
        if(VarName == 'InitialVelocity')
        {
            SetVelocity(InitialVelocity);
        }
    }
    //return;    
}

simulated function InitializeFrom(FoxDataProvider_GenericPickup inPickup)
{
    local int I;

    Provider = inPickup;
    Provider.Initialize();
    ProviderName = inPickup.Name;
    // End:0xBC
    if(Provider.ResolvedMesh != none)
    {
        PickupMesh.SetStaticMesh(Provider.ResolvedMesh);
    }
    // End:0x13D
    if(Provider.ActivePS != none)
    {
        ActivePSC.SetTemplate(Provider.ActivePS);
        ActivePSC.ActivateSystem();
    }
    I = 0;
    J0x148:
    // End:0x1B8 [Loop If]
    if(I < PickupMesh.GetNumElements())
    {
        MICs.AddItem(PickupMesh.CreateAndSetMaterialInstanceConstant(I));
        ++ I;
        // [Loop Continue]
        goto J0x148;
    }
    // End:0x209
    if(Provider.Lifetime > 0.0)
    {
        SetTimer(Provider.Lifetime - float(1), false);
    }
    // End:0x22E
    if(Provider.AnnounceMessage != "")
    {
    }
    SetPhysics(2);
    // End:0x2F8
    if(Role == ROLE_Authority)
    {
        InitialVelocity = VRand() * float(500);
        InitialVelocity.Z = 500.0 * float(2);
        SetVelocity(InitialVelocity);
        // End:0x2EC
        if(Provider.ActivationTime > float(0))
        {
            SetTimer(Provider.ActivationTime, false, 'OnActivate');
        }
        // End:0x2F8
        else
        {
            bActivated = true;
        }
    }
    //return;    
}

function OnActivate()
{
    bActivated = true;
    //return;    
}

simulated function SetVelocity(Vector Invelocity)
{
    SetPhysics(2);
    Velocity = Invelocity;
    //return;    
}

event Landed(Vector HitNormal, Actor FloorActor)
{
    super(DroppedPickup).Landed(HitNormal, FloorActor);
    RotationRate = Provider.RotationRate;
    SetPhysics(5);
    //return;    
}

function GiveTo(Pawn P)
{
    local FoxPawn FP;

    FP = FoxPawn(P);
    Provider.AwardTo(FP);
    // End:0xD0
    if(Provider.PickupPS != none)
    {
        WorldInfo.MyEmitterPool.SpawnEmitter(Provider.PickupPS, Location, Rotation, self);
    }
    PickedUpBy(P);
    //return;    
}

auto state Pickup
{
    function bool ValidTouch(Pawn Other)
    {
        local FoxPawn FP;

        // End:0x11
        if(!bActivated)
        {
            return false;
        }
        FP = FoxPawn(Other);
        // End:0xD7
        if((((Other == none) || !Other.IsHumanControlled()) || !Other.bCanPickupInventory) || (Other.DrivenVehicle == none) && Other.Controller == none)
        {
            return false;
        }
        // End:0x132
        if((FP != none) && !FP.IsAliveAndWell() || FP.IsInjured())
        {
            return false;
        }
        // End:0x187
        if(((Physics == 2) && Other == Instigator) && Velocity.Z > float(0))
        {
            return false;
        }
        // End:0x1CD
        if(!FastTrace(Other.Location, Location))
        {
            SetTimer(0.50, false, 'RecheckValidTouch');
            return false;
        }
        // End:0x1FC
        if(!Provider.CanPickup(Other))
        {
            return false;
        }
        return true;
        //return ReturnValue;        
    }
    stop;    
}

state FadeOut
{
    simulated event BeginState(name PreviousStateName)
    {
        super.BeginState(PreviousStateName);
        LifeSpan = 0.0;
        //return;        
    }
    stop;    
}

defaultproperties
{
    begin object name=ActivePSC0 class=ParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxDroppedPickup_Generic.ActivePSC0'
    ActivePSC=ActivePSC0
    begin object name=StaticMesh0 class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDroppedPickup_Generic.MyLightEnvironment'
        bCastDynamicShadow=false
        CollideActors=false
        BlockActors=false
        BlockZeroExtent=false
        BlockNonZeroExtent=false
        BlockRigidBody=false
    object end
    // Reference: StaticMeshComponent'Default__FoxDroppedPickup_Generic.StaticMesh0'
    PickupMesh=StaticMesh0
    begin object name=HRVMat class=MaterialInstanceConstant
        Parent=Material'FX_Characters.MT.MT_HVT_Noise'
        ParentLightingGuid=(A=-1709246918,B=1299300049,C=-518210160,D=408981621)
        LightingGuid=(A=185123825,B=1117031224,C=1455283604,D=344181994)
    object end
    // Reference: MaterialInstanceConstant'Default__FoxDroppedPickup_Generic.HRVMat'
    HRVMaterial=HRVMat
    Components(0)=none
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=50.0
        CollisionRadius=80.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxDroppedPickup_Generic.CollisionCylinder'
    Components(1)=CollisionCylinder
    begin object name=MyLightEnvironment class=DynamicLightEnvironmentComponent
        bCastShadows=false
        bDynamic=false
        bSynthesizeSHLight=true
    object end
    // Reference: DynamicLightEnvironmentComponent'Default__FoxDroppedPickup_Generic.MyLightEnvironment'
    Components(2)=MyLightEnvironment
    begin object name=ActivePSC0 class=ParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxDroppedPickup_Generic.ActivePSC0'
    Components(3)=ActivePSC0
    begin object name=StaticMesh0 class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDroppedPickup_Generic.MyLightEnvironment'
        bCastDynamicShadow=false
        CollideActors=false
        BlockActors=false
        BlockZeroExtent=false
        BlockNonZeroExtent=false
        BlockRigidBody=false
    object end
    // Reference: StaticMeshComponent'Default__FoxDroppedPickup_Generic.StaticMesh0'
    Components(4)=StaticMesh0
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=50.0
        CollisionRadius=80.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxDroppedPickup_Generic.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}